          nolist
.vnum     setstr    {05}
          include   ram3_macro2_lib
* anwendung der vectoren fr parameter, basic-speicher und rechner-operationen
          
          section   DFV
          data      0

          lea       deftab(pc),a1       ;<einsprung mit LRESPR oder CALL
          move.w    $0110,a2            ; bp.init
          jmp       (a2)                ; und zurck nach basic

deftab    dc.w      2                   ; 2 proceduren
          dc.w      xgval-*
          dc.b      5,'XGVAL'           ; vertauscht zwei variable gleichen typs
          dc.w      defval-*
          dc.b      6,'DEFVAL',0        ; vorgabe fr undefinierten parm
          dc.w      0,5                 ; ende proc., 5 funktionen
          dc.w      defval.i-*          ; wie defval, ret fehlercode/0/parm.typ
          dc.b      7,'DEFVAL%'
          dc.w      noval.i-*           ; flag bei undefiniertem parm
          dc.b      6,'NOVAL%',0
          dc.w      isval.i-*           ; dto. umgekehrt
          dc.b      6,'ISVAL%',0
          dc.w      parm.i-*            ; anzahl definierter parm einer liste
          dc.b      5,'PARM%'
          dc.w      cmp-*
          dc.b      3,'CMP'
          dc.w      0                   ; ende funktionen
          dc.b      'DFV[.vnum].hpr91'
          ds.w      0

* Basic-variable gleichen Typs vertauschen.
* Dies ist ein vereinfachter Aufruf mit besonders geringer Laufzeit.
* Darin werden nur die Pointer zu den Variablenwerten umgsetzt.
* Dimensionierte Variable sind darum immer in vollem Umfang betroffen.
* Werden teile in einer aufgerufenen Procedur getauscht, wirkt das
* im Aufruf selber auf den gesamten Bereich der beiden Variablen.
XGVAL     moveq     #-15,d0             ; err.bp
          lea       16(a3),a3
          cmp.l     a3,a5
          bne.s     xdf_ret             ;? nicht genau zwei parm
          moveq     #-14,d0             ; err.ff
          move.b    -16(a3,a6.l),d1     ; verwendung (use)
          cmp.b     -8(a3,a6.l),d1      ;  des namen
          bne.s     xdf_ret             ;? nicht desselben typs
          moveq     #-17,d0             ; err.xp
          move.w    -14(a3,a6.l),d2     ; erster index zur name-table
          bmi.s     xdf_ret             ;? ausdruck
          move.w    -6(a3,a6.l),d3      ; zweiter index
          bmi.s     xdf_ret             ;? nicht erlaubt
          subq.b    #3,d1
          bne.s     xdf_ndm             ;? nicht dimensionierte var
          move.l    24(a6),a0           ; name-table
          move.l    a0,a1               ; copie
          lsl.w     #3,d2               ; erster offset in die name-table
          lsl.w     #3,d3               ; zweiter offset
          add.w     d2,a0
          add.w     d3,a1               ; austausch der werte-pointer
          move.l    4(a0,a6.l),d1       ;  bei dimensionierten variablen
          move.l    4(a1,a6.l),4(a0,a6.l)
          move.l    d1,4(a1,a6.l)
          moveq     #0,d0
xdf_ret   rts
xdf_ndm   move.w    d2,-6(a3,a6.l)      ; austausch der namen-pointer
          move.w    d3,-14(a3,a6.l)     ;   bei einfachen variablen
          moveq     #0,d0
          rts

* Anzahl definierter Parameter ab Anfang einer bergabeliste
* innerhalb einer Basic-Procedur oder -Funktion zurckgeben.
PARM.i    move.l    a5,d7               ; obergrenze name table
          sub.l     a3,d7               ; anfang dto.
          ble.s     prm_ret             ;? keiner da, ret 0
          lsr.l     #3,d7               ; gesamte anzahl
          move.l    d7,d6               ; merken
          moveq     #-1,d7              ; ergebniszhler
          subq.w    #1,d6               ; laufzhler
prm_glop  addq.w    #1,d7               ; beginnt mit 0
          lea       8(a3),a5            ; parm eingrenzen
          bsr.s     tst_val             ;> prfung auf gltigkeit
          bgt.s     prm_ret             ;? erster undefinierter parm
          addq.l    #8,a3               ; nchste bergabe
          addq.l    #1,d5               ; direkte eingabe gilt auch
          dbmi      d6,prm_glop         ; bis zum letzten parm
          bmi.s     prm_ret             ;? der ungltig ist
          addq.w    #1,d7               ; sonst diesen noch mitzhlen
prm_ret   move.w    d7,d5               ; ergebnis zurechtlegen
          bra.s     rt_d5krx            ; ret als einfache integer

* ret Flag 1 bei definiertem parm, sonst 0
ISVAL.i   bsr.s     tst_val             ;> (s. dort)
          addq.w    #1,d5               ; direkte eingabe gilt auch
          smi       d5                  ; flag ermitteln
          bra.s     isv_ntry            ; als integer abliefern

* ret Flag 1 bei nicht definiertem parm, sonst 0
NOVAL.i   bsr.s     tst_val             ;> entsprechend isval%
          addq.w    #1,d5
          spl       d5
isv_ntry  ext.w     d5                  ;<isval
          addq.w    #1,d5

* alles ntige zur bergabe von d5.w an basic
rt_d5krx  moveq     #2,d1               ; platz fr integer
          move.w    $011a,a2            ; bv.chrix
          jsr       (a2)                ;> platz machen
          subq.l    #2,$58(a6)          ; fr basic fixieren
          move.l    $58(a6),a1          ;<mit parm.stack a1  (16)int d5
          move.w    d5,0(a1,a6.l)       ; zahl bereitstellen
          moveq     #3,d4               ; integer-ergebnis signalisieren
          moveq     #0,d0               ; kein fehler
          rts                           ; an basic

* subroutine zur prfung eines basic-parameters und angabe des typen:
* kathegorie: 0 undefiniert 1 variable 2 array
* typ:        0 nichts      1 string   2 f.p.-zahl  3 integer
* RAUS: flags & d5 =/=0 parm unbekannt  d1.hi parm.typ d1.lo parm.kathegorie
*   mit d5 < 0 direkte eingabe, unbekannter name  d5 > 0 wert nicht angegeben
* NDERT: d0 d1 d5 a2 - ERHLT: alle bergabeparameter
tst_val   moveq     #-7,d5              ; err.nf fr die rckgabe
          moveq     #0,d0               ; register freimachen
          cmp.l     a3,a5               ; grenzen der name table 
          ble.s     tsv_ret             ;? nichts da
          moveq     #-1,d5              ; err.nc bei direktem ausdruck
          move.w    2(a3,a6.l),d0       ; index
          bmi.s     tsv_ret             ;? parm direkt als ausdruck
          moveq     #-17,d5             ; err.xp bei unbekanntem wert
          lsl.l     #3,d0               ; tabellenoffset aus dem index
          move.l    24(a6),a2           ; basis der name table
          add.l     d0,a2               ; tabellenplatz
          move.w    0(a2,a6.l),d0       ; {hi|lo}={kathegorie|hash.sepa.typ}
          moveq     #15,d1              ; hash und sepa wegnehmen, reg lschen
          and.b     d0,d1               ; nur variablentyp
          move.b    d1,d0               ;  bleibt brig
          ror.w     #8,d0               ; definitionen-kathegorie
          swap      d1                  ; getrennt
          move.b    d0,d1               ; copie der definitionen-kathegorie
          tst.b     4(a2,a6.l)          ; falls neg., copie oder unbekannt  
          bmi.s     tsv_ret             ;? kein wert bekannt
          moveq     #-15,d5             ; err.bp wenn alles falsch ist
          tst.l     d1                  ; typ & kathegorie
          beq.s     tsv_ret             ;? gibt es nicht
          moveq     #1,d5               ; immerhin ist der parm vorhanden
          tst.b     d0                  ; kathegorie
          beq.s     tsv_ret             ;? unbesetzte variable
          subq.w    #3,d0               ; dimensionierte variable
          beq.s     tsv_xit             ;? ist immer definiert
          subq.w    #1,d0               ; typ 4
          beq.s     tsv_ret             ;? basic-procedur
          subq.w    #4,d0               ; typ 8
          beq.s     tsv_ret             ;? code-procedur
tsv_xit   moveq     #0,d5               ; parm ist definiert
tsv_ret   tst.w     d5                  ; ergebnis der untersuchung
          rts                           ; ret mit entsprechenden flags

* Undefinierten parm mit Vorgabe besetzen, Fehlercode stets ohne Abbruch
* Aufruf der funktion                          nn=DEFVAL%(variable,vorgabe) 
* gibt nur undefinierter Variablen den Wert der Vorgabe, die im Typ passen mu.
* nn ist = 0        wenn definition aus Vorgabe erfolgt ist,
*        = typ      wenn Variable bereits definiert war,
*        < 0        wenn Vorgabe nicht in bentigten Typen wandelbar ist.
DEFVAL.i  pea       rt_d5krx(pc)        ; zahlenrckgabe aufsetzen

* Ansonsten ganz ohne Unterschied sorgt           DEFVAL variable,vorgabe
* als Procedur fr ggf. erforderliche Definition der Variablen mit
* dem Vorgabewert. Hier gibt unbrauchbare Vorgabe eine Fehlermeldung.
DEFVAL    moveq     #-7,d5              ; err.nf
          lea       16(a3),a4           ; zwei eintragungen eingrenzen
          cmp.l     a4,a5               ; bergabebereich
          bne.s     dfv_ret             ;? nicht 2 parm
          lea       -8(a4),a5           ; die 'variable' als
          bsr       tst_val             ;> ersten parm prfen
          beq.s     dfv_ret             ;? ist bekannt
          move.l    d1,d6               ; 1. kathegorie
          moveq     #-15,d5             ; err.bp
          subq.w    #3,d1
          bpl.s     dfv_ret             ;? nicht einfache variable
          move.l    a5,a3               ; untere grenze
          move.l    a4,a5               ; obere grenze
          bsr       tst_val             ;> 'vorgabe' als 2. parm prfen
          beq.s     dfv_chk             ;? ist definierte variable
          cmp.w     #-1,d5              ; vielleicht direkte eingabe
          bne.s     dfv_rret            ;? sonst gilt die vorgabe nicht
          move.l    d6,d1               ; 1. typ fr 2. parm annehmen
dfv_chk   moveq     #-4,d5              ; err.or
          move.l    d1,d7               ; als 2. kathegorie gltig: 1,2,5,6,7,9
          subq.w    #3,d1
          blt.s     dfv_set             ;? variable:      typ      1,2
          subq.w    #2,d1
          blt.s     dfv_rret            ;? feld / basic-proc 3,4
          subq.w    #3,d1               ; wrde gelten:             5,6,7
          beq.s     dfv_rret            ;? code-procedur     8
          subq.w    #1,d1               : wrde gelten:               9
          bgt.s     dfv_rret            ;? nichts brauchbares
dfv_set   moveq     #-18,d5             ; err.ov 
          moveq     #3,d1               ; offsetregister
          swap      d6                  ; definitionstyp ( 1.parm )
          sub.w     d6,d1               ; fr den offset zu gt.int
          bmi.s     dfv_ret             ;? falscher typ teilt sich mit
          add.w     d1,d1               ; gt.lint als fehlersituation
          move.w    d1,a2               ;  stirbt nachher mit bp.let
          move.w    $0112(a2),a2        ; entsprechend
          jsr       (a2)                ;> die vorgabe holen
          move.l    d0,d5               ; fehlercode daraus
          bmi.s     dfv_ret             ;? mitteilen
          move.l    a3,a5               ; grenzen fr den
          subq.l    #8,a3               ;  undefinierten parameter
          move.w    $0120,a2            ; bp.let
          jsr       (a2)                ;> versuchen
dfv_ret   move.l    d0,d5               ; fehlercode fr funktion merken
          moveq     #0,d0               ; ret an procedur ohne fehler
          rts
dfv_rret  move.l    d5,d0               ; fr fehlerabbruch der procedur
          rts

* Vergleich zweier Variabler nach Magabe des ersten Typs:
* CMP('abc','aba')=1          CMP('nana','nanu')=2          CMP('nix','nix')=0
* CMP(67890,12345)=1          CMP(123456,567890)=2          CMP(-9999,-9999)=0
* CMP('eins')=-7              CMP(nur,mll)=-17             CMP(123,456,000)=2
* Fehlerrckgabe mit Wert < 0, fr die Ergebnisse
*         0: 1. = 2.          1: 1. > 2.          2: 2. > 1.
* Strings werden erkannt und mit Vergleich zeichenweise gleichrangig behandelt.
* Ohne die Fehlerangaben ist bei geringem Umbau eine SGN-funktion realisierbar.
CMP       moveq     #-7,d5              ; err.nf
          lea       16(a3),a4           ; zwei eintragungen eingrenzen
          cmp.l     a4,a5               ; bergabebereich
          blt.s     cmp_ret             ;? nicht 2 parm
          moveq     #15,d7              ; bitmaske
          and.b     1(a3,a6.l),d7       ; 1. kathegorie
cmp_prm   moveq     #-15,d5             ; err.bp
          subq.w    #3,d7
          bgt.s     cmp_ret             ;? nicht einfache variable
          move.l    a4,a5               ; obere grenze der name table
          move.l    $58(a6),a4          ; obergrenze bergabebereich merken
          moveq     #2,d0               ; ofs fr ca.gtstr
          addq.w    #2,d7               ; typ 1 oder ausdruck
          ble.s     cmp_nnum            ;? als string holen
          moveq     #0,d0               ; bleibt ca.gtfp fr alle zahlen
cmp_nnum  move.l    d0,a2               ; parm passen holen
          move.w    $0114(a2),a2        ; vector fr die parm
          jsr       (a2)
          move.l    d0,d5               ; ggf. code zurckgeben
          bne.s     cmp_ret             ;? fehler bei der bergabe
          moveq     #-10,d5             ; err.ef
          subq.w    #2,d3               ;  falls
          bne.s     cmp_rret            ;? ein parm fehlt
          moveq     #0,d5               ; ergebnis bei gleichheit
          tst.w     d7                  ; nochmal der variablentyp
          beq.s     cmp_stg             ;? strings vergleichen
          move.w    0(a1,a6.l),d0       ; exponenten
          cmp.w     6(a1,a6.l),d0       ;  vergleichen
          bne.s     cmp_clc             ;? rechnen
          move.l    2(a1,a6.l),d0       ; mantissen
          cmp.l     8(a1,a6.l),d0       ;  vergleichen
          beq.s     cmp_rret            ;? zahlen gleichgro
cmp_clc   move.w    $011e,a2            ; ri.execb
          lea       cmp_calc(pc),a3     ; rechenanweisungen
          jsr       (a2)                ;  ausfhren
          tst.l     2(a1,a6.l)          ; vom ergebnis nur vorzeichen prfen
cmp_ncmp  slt       d5                  ; 1. > 2.
          ext.w     d5                  ; ret 16-bit-zahl
cmp_n1rt  addq.w    #1,d5               ;< 1.leerstring
cmp_n2rt  addq.w    #1,d5               ;< 2.leerstring
cmp_rret  move.l    a4,$58(a6)          ; parm-bereich freigeben
cmp_ret   bra       rt_d5krx            ; ret d5.w als funktionswert

* stringvergleich bei auswertung der unvernderten zeichen
* kommt  d0=d5=d7=0  a1 basis 1.string  a4 obergrenze parm-bereich
cmp_stg   move.w    0(a1,a6.l),d1       ; 1.len
          moveq     #1,d2               ; zum justieren
          and.w     d1,d2               ; 1.bereich mod 2
          add.w     d1,d2               ; geradzahlig aufgerundet
          lea       2(a1,d2.w),a2       ; 2.basis
          move.w    0(a2,a6.l),d3       ; 2.len
          bne.s     cmp_slen            ;? hat eine lnge
          tst.w     d1                  ; 1.len
          beq.s     cmp_rret            ;? beide leer
          bra.s     cmp_n2rt            ;- 2. leer bedeutet 1. > 2.
cmp_slen  tst.w     d1                  ;  1.len
          beq.s     cmp_n1rt            ;? 1. leer bedeutet 2. > 1.
          move.w    d3,d4               ; 2.len zum zhlen
          move.w    d3,d7               ; 2.len
          sub.w     d1,d7               ; 2.-1.len, neg. wenn 1. > 2.
          ble.s     cmp_tst             ;? richtiger zhler
          move.w    d1,d4               ; sonst 1.len
cmp_tst   subq.w    #1,d4               ; geringste lnge wird zum zhler
cmp_chr   addq.l    #1,a1               ; zeichenweise
          addq.l    #1,a2
          move.b    1(a2,a6.l),d1       ; bytes
          cmp.b     1(a1,a6.l),d1       ;  vergleichen
          dbne      d4,cmp_chr
          bne.s     cmp_ncmp            ;? ergebnis bei ungleichem inhalt
          tst.w     d7                  ; lngendifferenz
          bne.s     cmp_ncmp            ;? strings genau gleich
          bra.s     cmp_rret            ; sonst entscheidet die lnge

* rechner-befehle fr die sgn-funktion in CMP
cmp_calc  dc.b      $0c,$16,$12,$10,0,0 ; sub dup abs div trm adressenausgleich

          END
