* .hpr'92 - universelle tastenumsetzung fr alle roms.
*             - fr js-rom eingerichtet -
* vor allen anderen erweiterungen aufzurufen, die mit
* con-kanlen oder sonst der tastatur zusmmenhngen.
* TK2 kann vorher aktiviert werden.

* die zu ersetzende adresse wird ermittelt:
* nach reset des QL nichts laden, tk2 kann aktiv sein.
*         pl=PEEK_L(163900)
*         pr=PEEK_L(pl)
*         pt=PEEK_L(4+pr)
* pt ist dann der wert fr .keypol hier im code.

          section   jsk
          data      0

.keypol   setstr    {$02d08}            js-rom tastatur-interrupt
;keypol   setstr    {$00ec4}            minerva 1.82 (?)
;keypol   setstr    {$00f4a}            minerva 1.91 (?)

start     moveq     #0,d0               mt.inf
          trap      #1                  sysvari holen
          move.l    $3c(a0),a0          sv.plist
          move.l    (a0),a0             erster poll-int.
          move.l    4(a0),d0            ptr zum aufruf
          cmp.l     #[.keypol],d0       sollte die tastatur-routine sein
          bne.s     return              ? fehler oder umbau schon erledigt
          moveq     #$1d,d0             mit mt.rpoll alten aufruf
          trap      #1                  wegnehmen
          lea       poll(pc),a1         neue
          move.l    a1,4(a0)            routine
          moveq     #$1c,d0             mt.poll
          trap      #1                  einbauen
return    moveq     #0,d0
          rts

* poll-routine
* beim aufruf hat a6 die basis der systemvariablen
poll      move.l    $4c(a6),a2          tastatur-queue
          move.l    8(a2),-(a7)         ptr q.in
          jsr       [.keypol]           alte routine aufrufen
          moveq     #0,d0               reg freimachen
          move.l    $4c(a6),a2          sv.queue
          move.l    (a7)+,a4            mit altem ptr
          move.l    8(a2),d1            eingabe prfen
          sub.l     a4,d1               anzahl neuer zeichen
          dble      d1,mehr             ? taste(n)
          rts
mehr      move.b    (a4),d0              zeichen holen und
          move.b    table(pc,d0.w),(a4)+ bersetzt zurckgeben
          dbra      d1,mehr
          rts

* frei definierbare zeichenumsetzungtabelle. an die position, die dem
* ankommenden code entspricht,schreibt man den gewnschten neuen code:
table     dc.l      $40010203,$04050607,$08090a0b,$0c0d0e0f ; nul     0
          dc.l      $10111213,$14151617,$18191a1b,$1c1d1e1f ; dle     1
          dc.l      $2021a0b6,$24252f80,$293d2827,$2c9c2e2d ; space   2
          dc.l      $30313233,$34353637,$3839a484,$3b233a5f ; '0'     3
          dc.l      $22414243,$44454647,$48494a4b,$4c4d4e4f ; '@'     4
          dc.l      $50515253,$54555657,$585a5987,$3c2b263f ; 'P'     5
          dc.l      $5c616263,$64656667,$68696a6b,$6c6d6e6f ; '`'     6
          dc.l      $70717273,$74757677,$787a79a7,$3e2a5e7f ; 'p'     7
          dc.l      $00818283,$8d858699,$88898a8b,$8c7b8e8f ; ''     8
          dc.l      $5d919293,$94959660,$7c5b9a9b,$607d9e9f ; ''     9
          dc.l      $bca1a2a3,$98a5a69d,$a8a9aaab,$acadaeaf ; ''    0a
          dc.l      $b0b1b2b3,$b4b590b7,$b8b9babb,$7ebdbebf ; ''    0b
          dc.l      $c0c1c2c3,$c4c5c6c7,$c8c9cacb,$cccdcecf ; c.left 0c
          dc.l      $d0d1d2d3,$d4d5d6d7,$d8d9dadb,$dcdddedf ; c.up   0d
          dc.l      $e0e1e2e3,$e4e5e6e7,$e8e9eaeb,$ecedeeef ; caps   0e
          dc.l      $f0f1f2f3,$f4f5f6f7,$f8f9fafb,$fcfdfeff ; f3     0f

          end
